package gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.EmptyBorder;

import businessLogic.AdminManager;
import domain.Owner;
import domain.RuralHouse;

public class RequestDeleteHouseGUI extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private Owner owner;
	private JComboBox<RuralHouse> comboBox;
	private JButton btnDelete;
	private AdminManager am;
	JLabel feedback = new JLabel("");

	/**
	 * Create the frame.
	 */
	public RequestDeleteHouseGUI(Owner o) {
		am  = new AdminManager();
		this.owner = o;
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
	
		comboBox = new JComboBox<RuralHouse>(this.owner.getRuralHouses());
		comboBox.setBounds(75, 55, 332, 20);
		

		JRadioButton rdbtnIAmSure = new JRadioButton("I am sure");
		rdbtnIAmSure.setBounds(90, 154, 90, 23);
		
		btnDelete = new JButton("REQUEST");
		btnDelete.setBounds(90, 213, 90, 23);
		btnDelete.setEnabled(false);
		
		rdbtnIAmSure.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent e) {
				int state = e.getStateChange();
				if (state == ItemEvent.SELECTED){
					btnDelete.setEnabled(true);
				}
				else if (state == ItemEvent.DESELECTED){
					btnDelete.setEnabled(false);
				}
			}
		});
		contentPane.setLayout(null);
		contentPane.add(comboBox);
		contentPane.add(rdbtnIAmSure);
		contentPane.add(btnDelete);
		feedback.setBounds(90, 184, 274, 18);
		contentPane.add(feedback);
		
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				actionListenerButton(arg0);
				
			}

			
		});
	}
	
	private void actionListenerButton(ActionEvent e){
		RuralHouse toDel = (RuralHouse)comboBox.getSelectedItem();
		
		if(am.addDeletionRequest(toDel)){
			feedback.setText("Delete request sended");
			
		}else{
			feedback.setText("Request cannot be sended(Already sended)");
		}
	}
}
